#include <stm32f10x.h>  
#include "..\inc\delay.h"  
#include "type.h"

uint8_t  fac_us=0;//us
uint16_t fac_ms=0;//ms

void delay_init(u8 SYSCLK)  
{  
    SysTick->CTRL&=0xfffffffb;//bit2  HCLK/8  
    fac_us=SYSCLK/8;              
    fac_ms=(u16)fac_us*1000;  
}

void ChargeTimer_ms(u16 nms)                                     
{
    SysTick->LOAD=(u32)nms*fac_ms;//(SysTick->LOAD?24bit)  
    SysTick->VAL =0x00;
    SysTick->CTRL=0x01;
}

BOOL IsTimerArrived()
{
    u32 temp;            
    temp=SysTick->CTRL;  
    if(temp & 0x01 && !(temp & (1<<16))) return FALSE;
    SysTick->CTRL=0x00;
    SysTick->VAL =0X00;      
		return TRUE;
}

void delay_ms(u16 nms)  
{                   
    u32 temp;            
    SysTick->LOAD=(u32)nms*fac_ms;//(SysTick->LOAD?24bit)  
    SysTick->VAL =0x00;
    SysTick->CTRL=0x01;
    do  
    {  
        temp=SysTick->CTRL;  
    }  
    while(temp&0x01&&!(temp&(1<<16)));
    SysTick->CTRL=0x00;
    SysTick->VAL =0X00;      
}     

unsigned int outside = 0;

unsigned int delay_us(u32 nus)  
{         
    u32 temp;              
    SysTick->LOAD=nus*fac_us;
    SysTick->VAL=0x00;
    SysTick->CTRL=0x01;
    do  
    {  
        temp=SysTick->CTRL;  
			if(outside)
				break;
    }  
    while(temp&0x01&&!(temp&(1<<16)));
    SysTick->CTRL=0x00;
    SysTick->VAL =0X00;
		if(outside)
		{
			outside = 0;
			return 0;
		}
		
		return 1;
}  
