#ifndef __PS2_H
#define __PS2_H	 
#include "..\MIELIB\inc\delay.h"	   

#define EXTI9_5_IRQChannel         ((u8)0x17)  /* External Line[9:5] Interrupts */

#define SCL			7ul	/* D+ CLK */
#define SDA			6ul	/* D- DATA */

#if(SCL > 7)
	#define SCL_CORR	0x08
#else
	#define SCL_CORR	0x00
#endif

#if(SDA > 7)
	#define SDA_CORR	0x08
#else
	#define SDA_CORR	0x00
#endif

#define GPIOB_ODR_Addr    (GPIOB_BASE+12) //0x4001080C 
#define GPIOB_IDR_Addr    (GPIOB_BASE+8) 	//0x40010808 

//IO
#define BITBAND(addr, bitnum) ((addr & 0xF0000000) + 0x2000000 + ((addr & 0xFFFFF) << 5)+(bitnum << 2)) 
#define MEM_ADDR(addr)  *((volatile unsigned long  *)(addr)) 
#define BIT_ADDR(addr, bitnum)   MEM_ADDR(BITBAND(addr, bitnum)) 

#define PBout(n)   BIT_ADDR(GPIOB_ODR_Addr,n)
#define PBin(n)    BIT_ADDR(GPIOB_IDR_Addr,n)

#define PS2_SCL PBin(SCL)
#define PS2_SDA PBin(SDA)

#define PS2_SCL_OUT PBout(SCL)
#define PS2_SDA_OUT PBout(SDA)

//PS2_SCL.		  
#define PS2_SET_SCL_IN()  {GPIOB->CRL&=~(0xFul << ((SCL - SCL_CORR) * 4));GPIOB->CRL|=(0x8ul << ((SCL - SCL_CORR) * 4));}
#define PS2_SET_SCL_OUT() {GPIOB->CRL&=~(0xFul << ((SCL - SCL_CORR) * 4));GPIOB->CRL|=(0x3ul << ((SCL - SCL_CORR) * 4));}	  
//PS2_SDA.		  
#define PS2_SET_SDA_IN()  {GPIOB->CRL&=~(0xFul << ((SDA - SDA_CORR) * 4));GPIOB->CRL|=(0x8ul << ((SDA - SDA_CORR) * 4));}
#define PS2_SET_SDA_OUT() {GPIOB->CRL&=~(0xFul << ((SDA - SDA_CORR) * 4));GPIOB->CRL|=(0x3ul << ((SDA - SDA_CORR) * 4));}

#define PS_2_MOUSE    0x20
#define PS_2_KEYBOARD 0x10
#define PS_2_CMDMODE  0x00

extern unsigned char PS2_Status;
extern unsigned char PS2_DATA_BUF[16];
extern unsigned char MOUSE_ID;

void PS2_Init(void);
unsigned char PS2_Send_Cmd(unsigned char cmd);
void PS2_Set_Int(unsigned char en);
unsigned char PS2_Get_Byte(void);
void PS2_En_Data_Report(void);
void PS2_Dis_Data_Report(void);

#endif
