#include <stm32f10x.h>                        // STM32F10x Library Definitions
#include "./mouse.h"
#include "./ps_2.h"

unsigned char MOUSE_ID;
PS2_Mouse MouseX;

unsigned char t;
int init_stage;

unsigned char Init_Mouse(void)
{
	unsigned char t;
	PS2_Init();
	PS2_Set_Int(1);
	delay_ms(80);

	PS2_Status = PS_2_CMDMODE;
	t = PS2_Send_Cmd(PS_RESET);
	if (t != 0)return 1;
	t = PS2_Get_Byte();

	if (t != 0xFA) return 2;

	t = 0;

	while ((PS2_Status & 0x80) == 0)
	{
		t++;
		delay_ms(10);
		if (t>50)return 3;
	}

	PS2_Get_Byte();//0xAA  
	PS2_Get_Byte();//ID 0x00         

	PS2_Send_Cmd(SET_SAMPLE_RATE);
	if (PS2_Get_Byte() != 0xFA)return 4;//  
	PS2_Send_Cmd(0xC8);//200  
	if (PS2_Get_Byte() != 0xFA)return 5;//  
	PS2_Send_Cmd(SET_SAMPLE_RATE);//  
	if (PS2_Get_Byte() != 0xFA)return 6;//  
	PS2_Send_Cmd(0x64);//100  
	if (PS2_Get_Byte() != 0xFA)return 7;//  
	PS2_Send_Cmd(SET_SAMPLE_RATE);//  
	if (PS2_Get_Byte() != 0xFA)return 8;//  
	PS2_Send_Cmd(0x50);//80  
	if (PS2_Get_Byte() != 0xFA)return 9;//  
										//           
	PS2_Send_Cmd(GET_DEVICE_ID); //ID  
	if (PS2_Get_Byte() != 0xFA)return 10;//  
	MOUSE_ID = PS2_Get_Byte();//MOUSE ID       

	PS2_Send_Cmd(SET_SAMPLE_RATE);//  
	if (PS2_Get_Byte() != 0xFA)return 11;//  
	PS2_Send_Cmd(0x0A);//10  
	if (PS2_Get_Byte() != 0xFA)return 12;//           
	PS2_Send_Cmd(GET_DEVICE_ID); //ID  
	if (PS2_Get_Byte() != 0xFA)return 13;//  
	MOUSE_ID = PS2_Get_Byte();//MOUSE ID           

	PS2_Send_Cmd(SET_RESOLUTION);  //  
	if (PS2_Get_Byte() != 0xFA)return 14;//     
	PS2_Send_Cmd(0x03);
	if (PS2_Get_Byte() != 0xFA)return 15;//   
	PS2_Send_Cmd(SET_SCALING11);   //1:1  
	if (PS2_Get_Byte() != 0xFA)return 16;//   

	PS2_Send_Cmd(SET_SAMPLE_RATE); //  
	if (PS2_Get_Byte() != 0xFA)return 17;//     
	PS2_Send_Cmd(0x28);
	if (PS2_Get_Byte() != 0xFA)return 18;//   

	PS2_Send_Cmd(SET_REMOTE_MODE);
	if (PS2_Get_Byte() != 0xFA)return 19;//  

	return 0;
}
